| Qore Programming Language - C/C++ Library 1.0.8

Public Member Functions | Protected Attributes | List of all members
AutoLocker Class Reference

provides a safe and exception-safe way to hold locks in Qore, only to be used on the stack, cannot be dynamically allocated More...

`#include <QoreThreadLock.h>`

Collaboration diagram for AutoLocker:
[legend]

## Public Member Functions
DLLLOCAL | AutoLocker (QoreThreadLock *l)
| creates the object and grabs the lock
DLLLOCAL | AutoLocker (QoreThreadLock &l)
| creates the object and grabs the lock
DLLLOCAL | AutoLocker (QoreThreadLock *l, bool already_locked)
| creates the object and grabs the lock More...
DLLLOCAL | AutoLocker (QoreThreadLock &l, bool already_locked)
| creates the object and grabs the lock More...
DLLLOCAL | ~AutoLocker ()
| destroys the object and releases the lock

## Protected Attributes
QoreThreadLock * | lck
| the pointer to the lock that will be managed

## Detailed Description

provides a safe and exception-safe way to hold locks in Qore, only to be used on the stack, cannot be dynamically allocated

Ensures that locks are released by locking the lock when the object is created and releasing it when the object is destroyed. For a similar object that allows for unlocking the lock earlier than the object's destruction, see SafeLocker.

See also
  AutoUnlocker
  SafeLocker
  OptLocker

## Constructor & Destructor Documentation

## ◆ AutoLocker() [1/2]

DLLLOCAL AutoLocker::AutoLocker | ( | QoreThreadLock * | l,
|  | bool | already_locked
| ) |  |
| inline

creates the object and grabs the lock

Since
  Qore 0.9

## ◆ AutoLocker() [2/2]

DLLLOCAL AutoLocker::AutoLocker | ( | QoreThreadLock & | l,
|  | bool | already_locked
| ) |  |
| inline

creates the object and grabs the lock

Since
  Qore 0.9

The documentation for this class was generated from the following file:

- include/qore/QoreThreadLock.h